/**
   The prettyPrint() method takes a BTree and
   converts it into a well formatted string.
*/

public class PrettyPrinter
{
   public static String prettyPrint(BTree tree)
   {
      return prettyPrint(tree, "");
   }

   /**
      This prettyPrint() method is essentially
      a pre-order traversal of the tree.
   */
   private static String prettyPrint(BTree tree, String indentation)
   {
      String result = indentation;

      if ( 0 == tree.degree() )  // what if this used tree.depth()?
      {
         result += tree.getElement();
      }
      else
      {
         // "process" the root node
         result += "(" + tree.getElement();

         // recursively traverse the left sub tree
         if ( null != tree.getLeftTree() )
            result += "\n" + prettyPrint( tree.getLeftTree(), indentation + "  " );
         else
            result += "\n" + indentation + "  ()";

         // recursively traverse the right sub tree
         if ( null != tree.getRightTree() )
            result += "\n" + prettyPrint( tree.getRightTree(), indentation + "  " );
         else
            result += "\n" + indentation + "  ()";

         result += "\n" + indentation + ")";
      }

      return result;
   }//prettyPrint()

}//PrettyPrinter
