/**
   The preOrder() method prints out an pre-order
   traversal of the nodes of a BTree.

   The inOrder() method prints out an in-order
   traversal of the nodes of a BTree.

   The postOrder() method prints out an post-order
   traversal of the nodes of a BTree.
*/

public class Traverse_v2
{
   public static String preOrder(BTree tree)
   {
      String result = "";

      if (tree != null)
      {
         // "process" the root node
         result += tree.getElement() + " ";

         // recursively traverse the left sub tree
         result += preOrder( tree.getLeftTree() );

         // recursively traverse the right sub tree
         result += preOrder( tree.getRightTree() );
      }
      return result;
   }


   public static String inOrder(BTree tree)
   {
      String result = "";

      if (tree != null)
      {
         // recursively traverse the left sub tree
         result += inOrder( tree.getLeftTree() );

         // "process" the root node
         result += tree.getElement() + " ";

         // recursively traverse the right sub tree
         result += inOrder( tree.getRightTree() );
      }
      return result;
   }


   public static String postOrder(BTree tree)
   {
      String result = "";

      if (tree != null)
      {
         // recursively traverse the left sub tree
         result += postOrder( tree.getLeftTree() );

         // recursively traverse the right sub tree
         result += postOrder( tree.getRightTree() );

         // "process" the root node
         result += tree.getElement() + " ";
      }
      return result;
   }

}
